PGOBLIN_BANG(-qf)
 -- Copyright (C)2009..2017 @BABOLO http://www.babolo.ru/
 -- PKG = mini-cipa-dripa
 -- All rights reserved.
 --
 -- Redistribution and use in source and binary forms, with or without
 -- modification, are permitted provided that the following conditions
 -- are met:
 -- 1. Redistributions of source code must retain the above copyright
 --    notice, this list of conditions and the following disclaimer.
 -- 2. Redistributions in binary form must reproduce the above copyright
 --    notice, this list of conditions and the following disclaimer in the
 --    documentation and/or other materials provided with the distribution.
 --
 -- THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 -- ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 -- IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 -- ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 -- FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 -- DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 -- OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 -- HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 -- LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 -- OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 -- SUCH DAMAGE.
 --
 -- $Id: minicipa.pgoblin.m4,v 1.5 2017/04/03 20:19:15 babolo Exp $

#connect 0001
pDBMS
GETARG(,1)
#perform 0001
CREATE TEMP TABLE SQNM(x)(SQAT(x) text, SQAT(n) text, SQAT(p) text);
#perform 0001
CREATE TEMP TABLE SQNM(s)(SQAT(i) integer, SQAT(s) text);
#perform 0001
INSERT INTO SQNM(x) VALUES(NULL, NULL, NULL);
#select 2001
SELECT SQAT(a) FROM SQNM(a) WHERE SQAT(i) = 0;
#perform 0021
UPDATE SQNM(x) SET SQAT(x) = ?;
#select 2001
SELECT SQAT(a) FROM SQNM(a) WHERE SQAT(i) = 1;
#perform 0021
UPDATE SQNM(x) SET SQAT(n) = ?;
#select 2001
SELECT SQAT(a) FROM SQNM(a) WHERE SQAT(i) = 2;
#perform 0021
UPDATE SQNM(x) SET SQAT(p) = ?;
#perform 0001
UPDATE SQNM(x) SET SQAT(p) = SQAT(p) || '/' WHERE NOT (SQAT(p) LIKE '%/');
#perform 0001
UPDATE SQNM(x) SET SQAT(p) = '' WHERE SQAT(p) IS NULL;
#select 2001
SELECT '#!
##echo
No WWW var directory suplied

##exit
1
'FROM SQNM(x) WHERE SQAT(x) IS NULL
;
#eval 02
#select 2001
SELECT 'wwwDBMS ' || SQAT(x) || '/minicipa.sqlite' FROM SQNM(x);
#connect 0203
#--####################################################################################################
 --                                                              #
 --#############################################################################
#trap
#return
#perform 0003                                                                   ________(DBinfra, pset)
CREATE TABLE SQNM(pset)
     ( SQAT(l)    integer NOT NULL PRIMARY KEY
     , SQAT(t)    integer NOT NULL
     , SQAT(c)    text    NOT NULL
     , SQAT(m)    text    NOT NULL
     , SQAT(w)    text    NOT NULL
     , UNIQUE(SQAT(m), SQAT(w))
     )
;
#-- pset  
 -- pset.l   
 -- pset.t  
 -- pset.  
 -- pset.m  
 -- pset.w    
#untrap
#trap
#return
#perform 0003                                                                  ________(DBinfra, pnode)
CREATE TABLE SQNM(pnode)
     ( SQAT(p)    integer NOT NULL PRIMARY KEY
     , SQAT(h)    text    NOT NULL
     , SQAT(m)    text    NOT NULL
     , SQAT(v)    text    NOT NULL
     , UNIQUE(SQAT(m), SQAT(v))
     )
;
#-- pnode  
 -- pnode.p  
 -- pnode.h 
 -- pnode.m  
 -- pnode.v    
#untrap
#trap
#return
#perform 0003                                                                  ________(DBinfra, pleaf)
CREATE TABLE SQNM(pleaf)
     ( SQAT(p)    integer NOT NULL REFERENCES SQNM(pnode)(SQAT(p))
     , SQAT(r)    integer       -- REFERENCES SQNM(pnode)(SQAT(p))  SQNM(pregi)(SQAT(x))
     , SQAT(l)    integer          REFERENCES SQNM(pset)(SQAT(l))
     , SQAT(o)    integer NOT NULL
     , SQAT(s)    text
     )
;
#-- pleaf  
 -- pleaf.p  
 -- pleaf.r     
 -- pleaf.l   
 -- pleaf.o    
 -- pleaf.s   
#untrap
#trap
#return
#perform 0003                                                                  ________(DBinfra, pcoll)
CREATE TABLE SQNM(pcoll)
     ( SQAT(x)    integer NOT NULL PRIMARY KEY
     , SQAT(m)    text    NOT NULL
     , SQAT(u)    text    NOT NULL
     , UNIQUE(SQAT(m), SQAT(u))
     )
;
#-- pcoll  
 -- pcoll.x  
 -- pcoll.m  
 -- pcoll.u  
#untrap
#trap
#return
#perform 0003                                                                  ________(DBinfra, pregi)
CREATE TABLE SQNM(pregi)
     ( SQAT(x)    integer NOT NULL REFERENCES SQNM(pcoll)(SQAT(x))
     , SQAT(r)    integer NOT NULL REFERENCES SQNM(pnode)(SQAT(p))
     , SQAT(o)    integer NOT NULL
     , SQAT(s)    text
     )
;
#-- pregi 
 -- pregi.x  
 -- pregi.r 
 -- pregi.o    
 -- pregi.s   
#untrap
#--####################################################################################################
 --                                                                   #
 --#############################################################################
#perform 0001
CREATE TEMP TABLE SQNM(ps)
     ( SQAT(t)    integer NOT NULL
     , SQAT(c)    text
     , SQAT(w)    text    NOT NULL
     )
;
#-- ps   pset
 -- ps.t  
 -- ps.c  
 -- ps.w    

#perform 0001
CREATE TEMP TABLE SQNM(pn)
     ( SQAT(v)    text    NOT NULL
     , SQAT(h)    text    NOT NULL
     )
;
#-- pn   pnode
 -- pn.v    
 -- pn.h 

#perform 0001
CREATE TEMP TABLE SQNM(pl)
     ( SQAT(f)    integer NOT NULL
     , SQAT(o)    integer NOT NULL
     , SQAT(v)    text    NOT NULL
     , SQAT(r)    text
     , SQAT(w)    text    NOT NULL
     , SQAT(a)    text
     , SQAT(s)    text
     )
;
#-- pl   pleaf  pregi
 -- pl.f  
 -- pl.o    
 -- pl.v    
 -- pl.r     NULL   
 -- pl.w  
 -- pl.a     NULL   
 -- pl.s HTTP GET 
#--####################################################################################################
 --                                                         #
 --#############################################################################
#cat 1
pnode
#copyin 0011
COPY SQNM(pn) FROM stdin;
#close 101
#cat 1
pset
#copyin 0011
COPY SQNM(ps) FROM stdin;
#close 101
#cat 1
pleaf
#copyin 0011
COPY SQNM(pl) FROM stdin;
#close 101
SEEPL(1)dnl                                                            ================================
#--####################################################################################################
 --                                                         #
 --#############################################################################
#select 2001
SELECT SQAT(p) FROM SQNM(x);
#perform 0021
UPDATE SQNM(ps) SET SQAT(c) = ? || SQNM(ps).SQAT(w) WHERE SQNM(ps).SQAT(c) IS NULL;
#select 2001
SELECT SQNM(x).SQAT(n), SQNM(pl).SQAT(w) FROM SQNM(pl), SQNM(x) WHERE SQNM(pl).SQAT(f) = 3;
#perform 0023
INSERT OR IGNORE INTO SQNM(pcoll)(SQAT(m), SQAT(u)) VALUES(?, ?);
#select 2001
SELECT SQNM(pn).SQAT(h), SQNM(x).SQAT(n), pn.SQAT(v) FROM SQNM(pn), SQNM(x);
#perform 0023
INSERT OR IGNORE INTO SQNM(pnode)(SQAT(h), SQAT(m), SQAT(v)) VALUES(?, ?, ?);
#select 2001
SELECT SQNM(ps).SQAT(t), SQNM(ps).SQAT(c), SQNM(x).SQAT(n), SQNM(ps).SQAT(w) FROM SQNM(ps), SQNM(x);
#perform 0023
INSERT OR IGNORE INTO SQNM(pset)(SQAT(t), SQAT(c), SQAT(m), SQAT(w)) VALUES(?, ?, ?, ?);
#select 2001
SELECT SQNM(ps).SQAT(t), SQNM(ps).SQAT(c), SQNM(x).SQAT(n), SQNM(ps).SQAT(w) FROM SQNM(ps), SQNM(x);
#perform 0023
UPDATE SQNM(pset) SET SQAT(t) = ?, SQAT(c) = ? WHERE SQNM(pset).SQAT(m) = ? AND SQNM(pset).SQAT(w) = ?;
#select 2001
SELECT SQNM(pn).SQAT(h), SQNM(x).SQAT(n), SQNM(pn).SQAT(v) FROM SQNM(pn), SQNM(x);
#perform 0023
UPDATE SQNM(pnode) SET SQAT(h) = ? WHERE SQNM(pnode).SQAT(m) = ? AND SQNM(pnode).SQAT(v) = ?;
#--####################################################################################################
 --                               DBinfra                          #
 --#############################################################################
#perform 0003
CREATE TEMP TABLE SQNM(ps)
     ( SQAT(t)    integer NOT NULL
     , SQAT(c)    text
     , SQAT(w)    text    NOT NULL
     )
;
#perform 0003
CREATE TEMP TABLE SQNM(pn)
     ( SQAT(v)    text    NOT NULL
     , SQAT(h)    text    NOT NULL
     )
;
#perform 0003
CREATE TEMP TABLE SQNM(pl)
     ( SQAT(f)    integer NOT NULL
     , SQAT(o)    integer NOT NULL
     , SQAT(v)    text    NOT NULL
     , SQAT(r)    text
     , SQAT(w)    text    NOT NULL
     , SQAT(a)    text
     , SQAT(s)    text
     )
;
#copyout 2001
COPY SQNM(ps) TO stdout;
#copyin 0023
COPY SQNM(ps) FROM stdin;
#copyout 2001
COPY SQNM(pn) TO stdout;
#copyin 0023
COPY SQNM(pn) FROM stdin;
#copyout 2001
COPY SQNM(pl) TO stdout;
#copyin 0023
COPY SQNM(pl) FROM stdin;
#close 202
SEEPL(3)dnl                                                            ================================
#select 2001
SELECT SQAT(n) FROM SQNM(x);
#select 3001
SELECT SQAT(n), SQAT(n) FROM SQNM(x);
SEEPLEAF(3)dnl                                                         ================================
#perform 0023
DELETE FROM SQNM(pleaf)
 WHERE SQAT(p) IN(SELECT SQNM(pnode).SQAT(p) FROM SQNM(pnode) WHERE SQNM(pnode).SQAT(m) = ?)
;
SEEPLEAF(3)dnl                                                         ================================
#perform 0023
DELETE FROM SQNM(pregi)
 WHERE SQAT(r) IN(SELECT SQNM(pnode).SQAT(p) FROM SQNM(pnode) WHERE SQNM(pnode).SQAT(m) = ?)
;
#perform 0023 --    pset
INSERT INTO SQNM(pleaf)(SQAT(p), SQAT(l), SQAT(o), SQAT(s))
 SELECT SQNM(pnode).SQAT(p), SQNM(pset).SQAT(l), SQNM(pl).SQAT(o), SQNM(pl).SQAT(s)
  FROM SQNM(pnode) JOIN SQNM(pl) USING(SQAT(v)) JOIN SQNM(pset) USING(SQAT(w))
  WHERE SQNM(pl).SQAT(f) = 1
    AND COALESCE(SQNM(pnode).SQAT(m) = SQNM(pl).SQAT(a), SQNM(pnode).SQAT(m) = ?)
;
SEEPLEAF(3)dnl                                                         ================================
#perform 0023 --  
INSERT INTO SQNM(pleaf)(SQAT(p), SQAT(r), SQAT(o), SQAT(s))
 SELECT SQNM(pnode).SQAT(p), SQNM(ref).SQAT(p), SQNM(pl).SQAT(o), SQNM(pl).SQAT(s)
  FROM  SQNM(pnode)
   JOIN SQNM(pl) USING(SQAT(v))
   JOIN SQNM(pnode) AS SQNM(ref)
     ON(SQNM(pl).SQAT(r) = SQNM(ref).SQAT(m) AND SQNM(pl).SQAT(w) = SQNM(ref).SQAT(v))
  WHERE SQNM(pl).SQAT(f) = 2
    AND COALESCE(SQNM(pnode).SQAT(m) = SQNM(pl).SQAT(a), SQNM(pnode).SQAT(m) = ?)
;
SEEPLEAF(3)dnl                                                         ================================
#perform 0033 --   
INSERT INTO SQNM(pleaf)(SQAT(p), SQAT(r), SQAT(l), SQAT(o), SQAT(s))
 SELECT SQNM(pnode).SQAT(p), SQNM(pcoll).SQAT(x), 0, SQNM(pl).SQAT(o), SQNM(pl).SQAT(s)
  FROM  SQNM(pnode) JOIN SQNM(pl) USING(SQAT(v)) JOIN SQNM(pcoll) ON(SQNM(pl).SQAT(w) = SQNM(pcoll).SQAT(u))
  WHERE SQNM(pl).SQAT(f) = 3
    AND SQNM(pcoll).SQAT(m) = ?
    AND COALESCE(SQNM(pnode).SQAT(m) = SQNM(pl).SQAT(a), SQNM(pnode).SQAT(m) = ?)
;
SEEPLEAF(3)dnl                                                         ================================
#perform 0023 --  
INSERT INTO SQNM(pregi)(SQAT(x), SQAT(r), SQAT(o), SQAT(s))
 SELECT SQNM(pcoll).SQAT(x), SQNM(pnode).SQAT(p), SQNM(pl).SQAT(o), SQNM(pl).SQAT(s)
  FROM  SQNM(pnode)
   JOIN SQNM(pl) USING(SQAT(v))
   JOIN SQNM(pcoll) ON(SQNM(pl).SQAT(w) = SQNM(pcoll).SQAT(u) AND SQNM(pl).SQAT(r) = SQNM(pcoll).SQAT(m))
  WHERE SQNM(pl).SQAT(f) = 4 AND COALESCE(SQNM(pnode).SQAT(m) = SQNM(pl).SQAT(a), SQNM(pnode).SQAT(m) = ?)
;
#perform 0023 --   ,      ,    ps
DELETE FROM SQNM(pnode)
 WHERE SQAT(p) IN(SELECT SQNM(pleaf).SQAT(p) FROM SQNM(pleaf)
             WHERE SQNM(pleaf).SQAT(l) IN(SELECT SQNM(pset).SQAT(l) FROM SQNM(pset)
                               WHERE SQNM(pset).SQAT(m) = ?
                                 AND SQNM(pset).SQAT(w) NOT IN(SELECT SQNM(ps).SQAT(w) FROM SQNM(ps))
           )                 )
;
#perform 0023 --    ,    ps
DELETE FROM SQNM(pleaf)
 WHERE SQAT(l) IN(SELECT SQNM(pset).SQAT(l) FROM SQNM(pset)
             WHERE SQNM(pset).SQAT(m) = ? AND SQNM(pset).SQAT(w) NOT IN(SELECT SQNM(ps).SQAT(w) FROM SQNM(ps))
           )
;
SEEPLEAF(3)dnl                                                         ================================
#perform 0023 --  ,    pn
DELETE FROM SQNM(pnode) WHERE SQAT(m) = ? AND SQAT(v) NOT IN(SELECT SQNM(pn).SQAT(v) FROM SQNM(pn));
#perform 0023 --  ,    ps
DELETE FROM SQNM(pset)  WHERE SQAT(m) = ? AND SQAT(w) NOT IN(SELECT SQNM(ps).SQAT(w) FROM SQNM(ps));
#
